<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr=96000 
ksmps=128
nchnls=2
0dbfs=1

giEQ1	ftgen 1000,0,8192,-7,1,8192, 1 
giEQ2	ftgen 1001,0,8192,-7,1,8192, 1 


	opcode pvshift2, 0, iiii

; our input values are:
; kpitch - pitch shift amount [.5=down octave,
; 1=noshift, 2=up octave, etc]
; kstretch - spectral shift amount [ususal range is
; .99-1.01, where 1=nostretch]
; inumbins - number of fft bins [size of tables]
; iampin - table containing amp data
; iampout - table to write modified amp data
; ifreqin - table containing freq data
; ifreqout - table to write modified freq data

inumbins, iampin, iampout, iEQ xin

; make sure we start with an empty table
iclear 	ftgen 0, 0, inumbins, 2, 0
	tablecopy iampout, iclear
; perform a do-while loop, cycling through the tables and shifting pitch
kcount = 0
loop:

if (kcount < inumbins) then

kval 	table kcount, iampin
kEQ 	table kcount, iEQ
		tablew kval*(kEQ+0.0000001), kcount, iampout

endif

kcount = kcount+1

if (kcount < inumbins) kgoto loop


endop



	
instr 1

kdry	invalue "dry"
kdry	port kdry, 0.01

kwet	invalue "wet"
kwet	port kwet, 0.01


ain1, ain2	ins

 	denorm	ain1, ain2

ain1 dcblock2 ain1
ain2 dcblock2 ain2

; get input and do pvanal

ifftsize = p4
iol = p5
iNumBins = ifftsize/2 + 1
ihop = ifftsize/iol
iwindow = ifftsize*p6


idel=iwindow/sr
aout3	delay ain1,idel 
aout4	delay ain2,idel

fsig1 pvsanal ain1, ifftsize, ihop, iwindow, p7
fsig2 pvsanal ain2, ifftsize, ihop, iwindow, p7


iampin1 ftgen 0,0,iNumBins,2,0
iampout1 ftgen 0,0,iNumBins,2,0



iampin2 ftgen 0,0,iNumBins,2,0
iampout2 ftgen 2000,0,iNumBins,2,0


; export fsig to tables
kflag pvsftw fsig1, iampin1
if (kflag > 0) then ; only proc when frame is ready

; pitch shift/stretch
	pvshift2	iNumBins, iampin1, iampout1,giEQ1

; read modified data back to fsrc
	pvsftr fsig1, iampout1

endif


; export fsig to tables
kflag2 pvsftw fsig2, iampin2
if (kflag2 > 0) then ; only proc when frame is ready

; pitch shift/stretch
	pvshift2	iNumBins, iampin2, iampout2,giEQ2
; read modified data back to fsrc
	pvsftr fsig2, iampout2

endif

aout1 pvsynth fsig1
aout2 pvsynth fsig2


outs (aout1*kwet)+(aout3*kdry), (aout2*kwet)+(aout4*kdry)

endin	

instr 2
	ftsave "./EQ/EQ1.ftsave", 1, 1000
	ftsave "./EQ/EQ2.ftsave", 1, 1001

endin

	
	
</CsInstruments>
<CsScore>

f0 86400

e

</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 943 62 200 494
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView nobackground {65535, 65535, 65535}
ioSlider {5, 5} {20, 100} 0.000000 1.000000 0.000000 slider1
ioSlider {45, 5} {20, 100} 0.000000 1.000000 0.000000 slider2
ioSlider {85, 5} {20, 100} 0.000000 1.000000 0.000000 slider3
ioSlider {125, 5} {20, 100} 0.000000 1.000000 0.000000 slider4
ioSlider {165, 5} {20, 100} 0.000000 1.000000 0.000000 slider5
</MacGUI>

